﻿Imports System.Text

Public Class MakeLinkForm
    Private LinkHandle As Integer
    Private mIsInitializing As Boolean = False

    Private Sub MakeLinkForm_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated
        Dim DataString As New StringBuilder(256)
        Dim Color, retVal As Integer

        Combo1.Items.Add("Box")
        Combo1.Items.Add("PolyLine")
        Combo1.Items.Add("Circle")
        Combo1.Items.Add("Cloud")
        Combo1.Items.Add("Symbol")
        Combo1.Text = "Box"

        Select Case Me.Tag
            Case "EditLink"
                LinkHandle = GetLinkHandle(Channel)
                Color = GetLinkData(Channel, LinkHandle, 1, DataString) 'color
                Text3.Text = CStr(Color)

                DataString.Length = 0
                retVal = GetLinkData(Channel, LinkHandle, 6, DataString) 'string
                Text1.Text = DataString.ToString

                DataString.Length = 0
                retVal = GetLinkData(Channel, LinkHandle, 5, DataString) 'caption
                Text2.Text = DataString.ToString

                retVal = GetLinkData(Channel, LinkHandle, 7, DataString) 'hide outline

                If retVal > -1 Then
                    Check1.CheckState = retVal
                End If
                retVal = GetLinkData(Channel, LinkHandle, 8, DataString) 'hide caption
                If retVal > -1 Then
                    Check2.CheckState = retVal
                End If
                Label1.Enabled = False
                Combo1.Enabled = False
                mAddLink.Text = "Save"
        End Select
    End Sub

    Private Sub MakeLinkForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    Private Sub Combo1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo1.SelectedIndexChanged
        If mIsInitializing Then
            Exit Sub
        End If
        mAddLink.Enabled = True
    End Sub

    Private Sub mAddLink_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mAddLink.Click
        Dim StoreString, Caption As String
        Dim TextHeight As Double
        Dim EntType, Color, HideFlag, retVal As Integer

        StoreString = Text1.Text
        Caption = Text2.Text
        TextHeight = 0
        Color = Val(Text3.Text)

        HideFlag = (Check1.CheckState * 16) + (Check2.CheckState * 32)
        Select Case Combo1.Text
            Case "Box"
                EntType = 0
            Case "PolyLine"
                EntType = 1
            Case "Circle"
                EntType = 2
            Case "Cloud"
                EntType = 3
            Case "Symbol"
                EntType = 4
        End Select
        If Check1.CheckState = 1 Then 'hide the outline
            HideFlag = 16
        End If
        If Check2.CheckState = 1 Then 'hide the caption
            HideFlag = HideFlag + 32
        End If


        Select Case Me.Tag
            Case "MakeLink"
                retVal = MakeLink(Channel, StoreString, Caption, TextHeight, Color, HideFlag, EntType)
            Case "EditLink"
                retVal = SetLinkData(Channel, LinkHandle, 1, CStr(Color)) 'set the color
                retVal = SetLinkData(Channel, LinkHandle, 5, Caption) 'set the caption
                retVal = SetLinkData(Channel, LinkHandle, 6, StoreString) 'set the String that is stored
                retVal = SetLinkData(Channel, LinkHandle, 7, CStr(Check1.CheckState)) 'set the hide flag for the outline
                retVal = SetLinkData(Channel, LinkHandle, 8, CStr(Check2.CheckState)) 'set the hide flag for the caption
        End Select
        Me.Close()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Me.Close()
    End Sub
End Class