Option Strict Off
Option Explicit On 
Imports System
Imports System.Runtime.InteropServices


Module Declare_APIs
    Public Delegate Function LinkDialogCallBack(ByVal BufferPtr As Integer) As Integer
    Public Delegate Sub EventCallBackEx(ByVal ChannelNo As Integer, ByVal EventNumber As Integer, ByVal EventData As Integer)
    Public Delegate Sub EventCallBack(ByVal ChannelNo As Integer, ByVal EventNumber As Integer)
    Public Delegate Sub CoordsCallBack(ByVal hwnd As Integer, ByVal lParam As Integer)

    Declare Function AddRedlineReference Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String, ByVal CreateFlag As Integer) As Integer
    Declare Function BringLinkToFront Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LinkHandle As Integer, ByVal RedrawNow As Integer) As Integer
    Declare Function BringToTop Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Handle As Integer) As Integer
    Declare Function BypassContextMenu Lib "fleng32.dll" (ByVal Channel As Integer, ByVal MenuIndex As Integer, ByVal YesNo As Integer) As Integer
    Declare Function CenterAndZoom Lib "fleng32.dll" (ByVal Channel As Integer, ByVal X1 As Double, ByVal Y1 As Double, ByVal Height As Double) As Integer
    Declare Function CloseDataChannel Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function CloseDwgWindow Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function CloseEmbeddedOverLookWindow Lib "fleng32.dll" () As Integer
    Declare Function CloseOverLookWindow Lib "fleng32.dll" () As Integer
    Declare Function CompareFiles Lib "fleng32.dll" (ByVal CompareChannel As Integer, ByVal Channel1 As Integer, ByVal Channel2 As Integer, ByVal Color1 As Integer, ByVal Color2 As Integer, ByVal UseDialog As Integer) As Integer
    Declare Function CreateLinkEntity Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Handle As Integer, ByVal LinkType As Integer, ByVal StoreString As String, ByVal EntityType As Integer, ByVal NumPoints As Integer, ByRef PointsArray As Double, ByVal Radius As Double, ByVal Rotation As Double, ByVal SymbolName As String, ByVal SymbolScale As Double, ByVal RedrawFlag As Integer) As Integer
    Declare Function CreateLinkEntityStr Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Handle As Integer, ByVal LinkType As Integer, ByVal StoreString As String, ByVal EntityType As Integer, ByVal NumPoints As Integer, ByVal PointsStr As String, ByVal RadiusStr As String, ByVal RotationStr As String, ByVal SymbolName As String, ByVal SymbolScaleStr As String, ByVal RedrawFlag As Integer) As Integer
    Declare Function CreateRedEntity Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Handle As String, ByVal EntityType As Integer, ByVal NumPoints As Integer, ByRef PointsArray As Double, ByVal Radius As Double, ByVal Rotation As Double, ByVal SymbolName As String, ByVal SymbolScale As Double, ByVal NoteText As String, ByVal RedrawFlag As Integer) As Integer
    Declare Function CreateRedEntityStr Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Handle As String, ByVal EntityType As Integer, ByVal NumPoints As Integer, ByVal PointsStr As String, ByVal RadiusStr As String, ByVal RotationStr As String, ByVal SymbolName As String, ByVal SymbolScaleStr As String, ByVal NoteText As String, ByVal RedrawFlag As Integer) As Integer
    Declare Function CreateRedLayer Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayerName As String, ByVal VisibleFlag As Integer, ByVal Color As Integer) As Integer
    Declare Function DeleteLinkEntity Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Handle As Integer, ByVal EraseFlag As Integer) As Integer
    Declare Function DeleteRedEntity Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Handle As String, ByVal EraseFlag As Integer) As Integer
    Declare Function DeleteRedFills Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function DeleteRedLayer Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayerName As String) As Integer
    Declare Function DoDragDropLinkSymbol Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LinkType As Integer, ByVal SymbolName As String, ByVal SymbolScale As Double, ByVal ColorIndexOrRGB As String, ByVal Rotation As Double, ByVal DataString As String, ByVal OverwritePriority As Integer) As Integer
    Declare Function DoesTagExist Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String) As Integer
    Declare Function DrawDwgFile Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String) As Integer
    Declare Function DrawDwgFileView Lib "fleng32.dll" (ByVal Channel As Integer, ByVal dwgName As String, ByVal XCenter As Double, ByVal YCenter As Double, ByVal Height As Double, ByVal ViewpointX As Double, ByVal ViewpointY As Double, ByVal ViewpointZ As Double) As Integer
    Declare Function DrawThisTempFile Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String) As Integer
    Declare Function DuplicateSelectedLinks Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function DwgWindowSize Lib "fleng32.dll" (ByVal Channel As Integer, ByVal X1 As Integer, ByVal Y1 As Integer, ByVal w As Integer, ByVal h As Integer) As Integer
    Declare Function EmbeddedOverLookChangeChannel Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function EmbeddedOverlookSetReticleStyle Lib "fleng32.dll" (ByVal Style As Integer, ByVal FillColor As String, ByVal BorderColor As String) As Integer
    Declare Function EmbeddedOverLookWindowSize Lib "fleng32.dll" (ByVal Xpos As Integer, ByVal Ypos As Integer, ByVal wWidth As Integer, ByVal sHeight As Integer) As Integer
    Declare Function EmbeddedOverLookZoomPrevious Lib "fleng32.dll" () As Integer
    Declare Function EmbeddedOverLookZoomToReticle Lib "fleng32.dll" () As Integer
    Declare Function EndMeasure Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function ExportFile Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Drawing As String, ByVal ToDrawing As String) As Integer
    Declare Function FindEntityAtCoords Lib "fleng32.dll" (ByVal Channel As Integer, ByVal X As Double, ByVal Y As Double) As Integer
    Declare Function FindFirstLink Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function FindFirstTag Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String) As Integer
    Declare Function FindFirstTagTypeAndName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String, ByVal EntityType As String, ByVal EntityName As String) As Integer
    Declare Function FindNextLink Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function FindNextTag Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String) As Integer
    Declare Function FindNextTagTypeAndName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String, ByVal EntityType As String, ByVal EntityName As String) As Integer
    Declare Function FindPlineAreaByTag Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String) As Integer
    Declare Function FlashRedEntByTag Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String, ByVal Fcolor As Integer, ByVal Bcolor As Integer, ByVal Duration As Integer) As Integer
    Declare Function FLDrawBlock Lib "fleng32.dll" (ByVal Channel As Integer, ByVal BlockName As String) As Integer
    Declare Function FLEngineVersion Lib "fleng32.dll" (ByVal FullVersion As String) As Integer
    Declare Function FLFreeResources Lib "fleng32.dll" () As Integer
    Declare Function FLLogin Lib "fleng32.dll" (ByVal UserName As String, ByVal Password As String, ByVal UseDialog As Int32) As Integer
    Declare Function FLSetCursor Lib "fleng32.dll" (ByVal Channel As Integer, ByVal CusorIndex As Integer, ByVal CursorFileName As String) As Integer
    Declare Function FLSetDialogControlColors Lib "fleng32.dll" (ByVal TypeIndex As Integer, ByVal SubTypeIndex As Integer, ByVal Red As Integer, ByVal Green As Integer, ByVal Blue As Integer) As Integer
    Declare Function GetClickCoordStr Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Button As Integer, ByVal Units As Integer, ByVal Xposition As String, ByVal Yposition As String) As Integer
    Declare Function GetColorInfo Lib "fleng32.dll" (ByVal ColorNum As Integer, ByVal RGBVal As String, ByVal ColorName As String) As Integer
    Declare Function GetColorPaletteIndex Lib "fleng32.dll" (ByVal hwndParent As Integer, ByVal x As Integer, ByVal y As Integer, ByRef ColorNum As Integer, ByVal RGBstr As String, ByVal ColorName As String) As Integer
    Declare Function GetCurrentLayoutName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayoutName As String) As Integer
    Declare Function GetDrawingExtents Lib "fleng32.dll" (ByVal Channel As Integer, ByRef X1 As Double, ByRef Y1 As Double, ByRef X2 As Double, ByRef Y2 As Double) As Integer
    Declare Function GetDrawingExtentsStr Lib "fleng32.dll" (ByVal Channel As Integer, ByVal X1 As String, ByVal Y1 As String, ByVal X2 As String, ByVal Y2 As String) As Integer
    Declare Function GetDrawingWindowRectStr Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Left As String, ByVal Top As String, ByVal Right As String, ByVal Bottom As String) As Integer
    Declare Function GetDroppedFile Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String) As Integer
    Declare Function GetDwgCreateDate Lib "fleng32.dll" (ByVal Channel As Integer, ByVal CreateDate As String, ByVal CreateTime As String) As Integer
    Declare Function GetDwgEditTime Lib "fleng32.dll" (ByVal Channel As Integer, ByVal EditTime As String) As Integer
    Declare Function GetDwgElapsedTimer Lib "fleng32.dll" (ByVal Channel As Integer, ByVal ElapsedTime As String) As Integer
    Declare Function GetDwgName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String) As Integer
    Declare Function GetDwgThumbNail Lib "fleng32.dll" (ByVal DrawingFileName As String, ByVal BitmapFileName As String) As Integer
    Declare Function GetDwgUpdateDate Lib "fleng32.dll" (ByVal Channel As Integer, ByVal UpdateDate As String, ByVal UpdateTime As String) As Integer
    Declare Function GetEntityDataByTag Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String, ByVal Value As String) As Integer
    Declare Function GetEntityInfoByTag Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String, ByVal Value As String) As Integer
    Declare Function GetFirstBlockInsert Lib "fleng32.dll" (ByVal Channel As Integer, ByVal BlockName As String) As Integer
    Declare Function GetFirstBlockName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal BlockName As String) As Integer
    Declare Function GetFirstDroppedFile Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String) As Integer
    Declare Function GetFirstEntity Lib "fleng32.dll" (ByVal Channel As Integer, ByVal EntityType As String, ByVal LayoutList As String) As Integer
    Declare Function GetFirstEntityData Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String, ByVal Value As String) As Integer
    Declare Function GetFirstEntityInfo Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String, ByVal Value As String) As Integer
    Declare Function GetFirstLayerConfigName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayerConfigName As String) As Integer
    Declare Function GetFirstLayerName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayerName As String) As Integer
    Declare Function GetFirstLayoutName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayoutName As String) As Integer
    Declare Function GetFirstLinkSymbolName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal SymbolName As String) As Integer
    Declare Function GetFirstObjectDataField Lib "fleng32.dll" (ByVal Channel As Integer, ByVal TableName As String, ByRef NumFields As Integer, ByVal FieldName As String, ByVal FieldDescription As String, ByVal Value As String, ByVal FieldType As String) As Integer
    Declare Function GetFirstObjectDataTableField Lib "fleng32.dll" (ByVal Channel As Integer, ByVal TableName As String, ByRef NumFields As Integer, ByVal FieldName As String, ByVal FieldDescription As String, ByVal DefaultValue As String, ByVal FieldType As String) As Integer
    Declare Function GetFirstRasterReference Lib "fleng32.dll" (ByVal Channel As Integer, ByVal DrawingFileName As String, ByVal LayerName As String) As Integer
    Declare Function GetFirstRedFontStyleName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FontStyleName As String) As Integer
    Declare Function GetFirstRedLayerName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayerName As String) As Integer
    Declare Function GetFirstRedlineReference Lib "fleng32.dll" (ByVal Channel As Integer, ByVal RedlineFileName As String, ByVal ReferenceFileName As String) As Integer
    Declare Function GetFirstRedLineStyleName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LineStyleName As String) As Integer
    Declare Function GetFirstSelEntity Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String, ByVal Reserved As Integer) As Integer
    Declare Function GetFirstTextEntity Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function GetFirstViewName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal ViewName As String) As Integer
    Declare Function GetFirstXrefBlock Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String, ByVal BlockName As String) As Integer
    Declare Function GetFLConfig Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Index As Integer, ByRef Flag As Integer, ByVal StringVal As String) As Integer
    Declare Sub GetFLSn Lib "fleng32.dll" (ByVal SerialNum As String)
    Declare Function GetFLStatus Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As Integer) As Integer
    Declare Function GetLayerAttributes Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayerName As String, ByVal Attrib As Integer) As Integer
    Declare Function GetLinkData Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LinkHandle As Integer, ByVal DataType As Integer, ByVal DataString As String) As Integer
    Declare Function GetLinkHandle Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function GetLinkString Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LinkString As String) As Integer
    Declare Function GetLinkSymbolBitmap Lib "fleng32.dll" (ByVal Channel As Integer, ByVal SymbolName As String, ByVal Width As Integer, ByVal Height As Integer, ByVal BackColorIndexOrRGB As String, ByVal ForeColorIndexOrRGB As String, ByRef hBitmap As Integer) As Integer
    Declare Function GetLinkSymbolSize Lib "fleng32.dll" (ByVal Channel As Integer, ByVal SymbolName As String, ByVal SymbolFile As String, ByRef Width As Double, ByRef Height As Double) As Integer
    Declare Function GetLinkSymbolSizeStr Lib "fleng32.dll" (ByVal Channel As Integer, ByVal SymbolName As String, ByVal SymbolFile As String, ByVal SizeStr As String) As Integer
    Declare Function GetMasterRedlineFileName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal OriginalFileName As String, ByVal MasterFileName As String) As Integer
    Declare Function GetMeasure Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Measurement As String) As Integer
    Declare Function GetMultiplier Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As Integer, ByVal Mutiplier As String) As Integer
    Declare Function GetNamesViewInfoByTag Lib "fleng32.dll" (ByVal Channel As Integer, ByVal ViewName As String, ByVal Tag As String, ByVal Value As String) As Integer
    Declare Function GetNextBlockInsert Lib "fleng32.dll" (ByVal Channel As Integer, ByVal BlockName As String) As Integer
    Declare Function GetNextBlockName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal BlockName As String) As Integer
    Declare Function GetNextDroppedFile Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String) As Integer
    Declare Function GetNextEntity Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function GetNextEntityData Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String, ByVal Value As String) As Integer
    Declare Function GetNextEntityInfo Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String, ByVal Value As String) As Integer
    Declare Function GetNextLayerConfigName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayerConfigName As String) As Integer
    Declare Function GetNextLayerName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayerName As String) As Integer
    Declare Function GetNextLayoutName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayoutName As String) As Integer
    Declare Function GetNextLinkSymbolName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal SymbolName As String) As Integer
    Declare Function GetNextObjectDataField Lib "fleng32.dll" (ByVal Channel As Integer, ByVal TableName As String, ByRef NumFields As Integer, ByVal FieldName As String, ByVal FieldDescription As String, ByVal Value As String, ByVal FieldType As String) As Integer
    Declare Function GetNextObjectDataTableField Lib "fleng32.dll" (ByVal Channel As Integer, ByVal TableName As String, ByRef NumFields As Integer, ByVal FieldName As String, ByVal FieldDescription As String, ByVal DefaultValue As String, ByVal FieldType As String) As Integer
    Declare Function GetNextRasterReference Lib "fleng32.dll" (ByVal Channel As Integer, ByVal RasterFileName As String) As Integer
    Declare Function GetNextRedFontStyleName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FontStyleName As String) As Integer
    Declare Function GetNextRedLayerName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayerName As String) As Integer
    Declare Function GetNextRedlineReference Lib "fleng32.dll" (ByVal Channel As Integer, ByVal ReferenceFileName As String) As Integer
    Declare Function GetNextRedLineStyleName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LineStyleName As String) As Integer
    Declare Function GetNextSelEntity Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String, ByVal Reserved As Integer) As Integer
    Declare Function GetNextTextEntity Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function GetNextViewName Lib "fleng32.dll" (ByVal Channel As Integer, ByVal ViewName As String) As Integer
    Declare Function GetNextXrefBlock Lib "fleng32.dll" (ByVal Channel As Integer, ByVal BlockName As String) As Integer
    Declare Function GetNumberOfPages Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String) As Integer
    Declare Function GetNumSelectedEntities Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function GetPolygonAreaByHandle Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Handle As String) As Double
    Declare Function GetPrinterProperty Lib "fleng32.dll" (ByVal OptionIndex As Integer, ByVal Value As String) As Integer
    Declare Function GetRectCoords Lib "fleng32.dll" (ByVal Channel As Integer, ByRef X1 As Double, ByRef Y1 As Double, ByRef X2 As Double, ByRef Y2 As Double) As Integer
    Declare Function GetRectCoordsStr Lib "fleng32.dll" (ByVal Channel As Integer, ByVal X1 As String, ByVal Y1 As String, ByVal X2 As String, ByVal Y2 As String) As Integer
    Declare Function GetRedEntityProperties Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Handle As String, ByVal PropIndex As Integer, ByVal PropertyString As String) As Integer
    Declare Function GetRedLayerSettings Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayerName As String, ByVal PropIndex As Integer, ByVal ValueString As String) As Integer
    Declare Function GetRedlineAttribute Lib "fleng32.dll" (ByVal Channel As Integer, ByVal AttributeStr As String) As Integer
    Declare Function GetRedlineFileStatus Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String, ByVal Index As Integer, ByVal Reserved As String) As Integer
    Declare Function GetRedlinePath Lib "fleng32.dll" (ByVal Channel As Integer, ByVal RedlinePath As String) As Integer
    Declare Function GetUser Lib "fleng32.dll" (ByVal UserName As String, ByVal Password As String) As Integer
    Declare Function GetViewPoint Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Xpos As String, ByVal Ypos As String, ByVal Zpos As String) As Integer
    Declare Function GetWindowCoords Lib "fleng32.dll" (ByVal Channel As Integer, ByRef X1 As Double, ByRef Y1 As Double, ByRef X2 As Double, ByRef Y2 As Double) As Integer
    Declare Function GetWindowCoordsStr Lib "fleng32.dll" (ByVal Channel As Integer, ByVal X1 As String, ByVal Y1 As String, ByVal X2 As String, ByVal Y2 As String) As Integer
    Declare Function HatchRedEntByTag Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Tag As String) As Integer
    Declare Function HatchTextPlineByTag Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String, ByVal Delimeter As String) As Integer
    Declare Function HideAllLinks Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function HighlightPolygon Lib "fleng32.dll" (ByVal Channel As Integer, ByVal EntityHandle As String, ByVal Color As Integer) As Integer
    Declare Function IdentifyFileType Lib "fleng32.dll" (ByVal FileName As String) As Integer
    Declare Function ImageToPixelCoordsStr Lib "fleng32.dll" (ByVal Channel As Integer, ByVal X As String, ByVal Y As String) As Integer
    Declare Function ImportCadToRed Lib "fleng32.dll" (ByVal Channel As Integer, ByVal CadLayer As String, ByVal RedLayer As String, ByVal DelRedBeforeAddFlag As Integer, ByVal CreateNewRedLayerFlag As Integer) As Integer
    Declare Function InsertLinkSymbol Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LinkType As Integer, ByVal SymbolName As String, ByVal SymbolScale As Double, ByVal ColorIndexOrRGB As String, ByVal Rotation As Double, ByVal DataString As String, ByVal OverwritePriority As Integer) As Integer
    Declare Function IsAcadDwg Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String) As Integer
    Declare Function KillRedlineFlash Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function LinkReloadFile Lib "fleng32.dll" (ByVal Channel As Integer, ByVal RedrawNow As Integer) As Integer
    Declare Function LinkSaveNow Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function LoadBlockAttributes Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function LoadBlockInsertAttributes Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function LoadBlockInsertData Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function LoadBlockInsertInfo Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function LoadDatabaseLinkData Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function LoadExtendedData Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function LoadFileForData Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String) As Integer
    Declare Function LoadObjectData Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function LoadObjectDataTables Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function LoadPolygons Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function LoadTextEntities Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function MakeLink Lib "fleng32.dll" (ByVal Channel As Integer, ByVal StoreString As String, ByVal Capt As String, ByVal TextHeight As Double, ByVal Color As Integer, ByVal HideFlag As Integer, ByVal PlineFlag As Integer) As Integer
    Declare Function MakeRedAttributeTags Lib "fleng32.dll" (ByVal Channel As Short, ByVal RedLayer As String, ByVal TextToAddToNote As String, ByVal AddTextBeforeNoteFlag As Integer, ByVal AddSpaceFlag As Integer) As Integer
    Declare Function MouseClickAction Lib "fleng32.dll" (ByVal Channel As Integer, ByVal MouseButtonNum As Integer, ByVal TypeAction As Integer, ByVal SubAction As Integer, ByVal ThirdParam As Integer, ByVal MenuString As String) As Integer
    Declare Function MoveSelectedLinks Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function OEM_OpenDwgWindow Lib "fleng32.dll" (ByVal hParent As Integer, ByVal Channel As Integer, ByVal Xpos As Integer, ByVal Ypos As Integer, ByVal wWidth As Integer, ByVal sHeight As Integer, ByVal Code As Integer) As Integer
    Declare Function OpenDataChannel Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function OpenDwgWindow Lib "fleng32.dll" (ByVal hParent As Integer, ByVal Channel As Integer, ByVal Xpos As Integer, ByVal Ypos As Integer, ByVal wWidth As Integer, ByVal sHeight As Integer) As Integer
    Declare Function OpenDwgWindowName Lib "fleng32.dll" (ByVal ParentName As String, ByVal Channel As Integer, ByVal Xpos As Integer, ByVal Ypos As Integer, ByVal wWidth As Integer, ByVal sHeight As Integer) As Integer
    Declare Function OpenEmbeddedOverLookWindow Lib "fleng32.dll" (ByVal hParent As Integer, ByVal Channel As Integer, ByVal Xpos As Integer, ByVal Ypos As Integer, ByVal wWidth As Integer, ByVal sHeight As Integer) As Integer
    Declare Function OpenFileDialog Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileMask As String, ByVal FileTypes As String, ByVal Overwrite As Integer) As Integer
    Declare Function OpenOverLookWindow Lib "fleng32.dll" (ByVal hParent As Integer, ByVal Channel As Integer, ByVal Xpos As Integer, ByVal Ypos As Integer, ByVal wWidth As Integer, ByVal sHeight As Integer, ByVal WinTitle As String) As Integer
    Declare Function OverLookChangeChannel Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function PostDrawWndCommand Lib "fleng32.dll" (ByVal Channel As Integer, ByVal WinMessage As Integer, ByVal wParam As Integer, ByVal lParam As Integer) As Integer
    Declare Function PixelToImageCoordsStr Lib "fleng32.dll" (ByVal Channel As Integer, ByVal X As String, ByVal Y As String) As Integer
    Declare Function PlaceDwgNote Lib "fleng32.dll" (ByVal Channel As Integer, ByVal NoteStr As String, ByVal X1 As Double, ByVal Y1 As Double, ByVal Color As Integer, ByVal Height As Double, ByVal Length As String) As Integer
    Declare Function PlaceRectangle Lib "fleng32.dll" (ByVal Channel As Integer, ByVal X1 As Double, ByVal Y1 As Double, ByVal X2 As Double, ByVal Y2 As Double, ByVal Color As Integer) As Integer
    Declare Function PrintFile Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileMask As String, ByVal Dialog As Integer) As Integer
    Declare Function PrintFileOptions Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileMask As String, ByVal Mode As Integer, ByVal Selection As Integer, ByVal PScale As Double, ByVal AScale As Double, ByVal xoff As Double, ByVal yoff As Double, ByVal Copies As Integer) As Integer
    Declare Function PrintFileToFile Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileMask As String, ByVal OutFileMask As String, ByVal Mode As Integer, ByVal Selection As Integer, ByVal PScale As Double, ByVal AScale As Double, ByVal xoff As Double, ByVal yoff As Double, ByVal Copies As Integer) As Integer
    Declare Function RedEntFillByTag Lib "fleng32.dll" (ByVal Channel As Integer, ByVal TagName As String, ByVal FillType As Integer, ByVal Color As Integer, ByVal PaintNow As Integer) As Integer
    Declare Function RedlineReloadFile Lib "fleng32.dll" (ByVal Channel As Integer, ByVal RedrawNow As Integer) As Integer
    Declare Function RedlineSaveNow Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function RedSymbolPlaceAtDWGCoords Lib "fleng32.dll" (ByVal Channel As Integer, ByVal SymbolFile As String, ByVal SymbolName As String, ByVal Xcoord As Double, ByVal Ycoord As Double, ByVal ScaleFactor As Double) As Integer
    Declare Function RemoveRedlineReference Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String, ByVal DeleteFlag As Integer) As Integer
    Declare Function SaveRedlineReferencesToFile Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function SearchDialog Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String, ByVal FileNameMask As String, ByVal OverWriteFlag As Integer) As Integer
    Declare Function SelectLinkEntityByHandle Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LinkHandle As Integer, ByVal SelectFlag As Integer) As Integer
    Declare Function SendDrawWndCommand Lib "fleng32.dll" (ByVal Channel As Integer, ByVal WinMessage As Integer, ByVal wParam As Integer, ByVal lParam As Integer) As Integer
    Declare Function SendFLCommand Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Param1 As Integer, ByVal Param2 As Integer) As Integer
    Declare Function SendLinkToBack Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LinkHandle As Integer, ByVal RedrawNow As Integer) As Integer
    Declare Function SetActiveLayout Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayoutName As String, ByVal ApplyToCurrentFile As Integer) As Integer
    '*** obsolete after V12 - use SetEventCallBackEx *********
    'Declare Function SetClickSettings Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Index As Integer, ByVal dX As Integer, ByVal dY As Integer) As Integer
    '***************************************
    Declare Function SetCoordsCallBack Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Address As CoordsCallBack) As Integer
    Declare Function SetCurrentWorkingDir Lib "fleng32.dll" (ByVal Channel As Integer, ByVal WorkingPath As String) As Integer
    Declare Function SetEventCallBack Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Address As EventCallBack) As Integer
    Declare Function SetEventCallBackEx Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Address As EventCallBackEx) As Integer
    Declare Function SetFindLinkHandleMode Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function SetFlashColor Lib "fleng32.dll" (ByVal Channel As Integer, ByVal ForeGround As Integer, ByVal Background As Integer) As Integer
    Declare Function SetFLConfig Lib "fleng32.dll" (ByVal Channel As Integer, ByVal IndexNo As Integer, ByVal FlagNo As Integer, ByVal StrVal As String) As Integer
    Declare Function SetFLPrinter Lib "fleng32.dll" (ByVal PrinterName As String) As Integer
    Declare Function SetLayerAttributes Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayerName As String, ByVal Visible As Integer, ByVal ColorIndex As Integer) As Integer
    '*** obsolete after V12 - use SetActiveLayout *********
    'Declare Function SetLayout Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayoutName As String, ByVal ApplyToCurrentFile As Integer) As Integer
    '******************************************************
    Declare Function SetLinkData Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LinkHandle As Integer, ByVal DataType As Integer, ByVal DataString As String) As Integer
    Declare Function SetLinkDialogCallback Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Address As LinkDialogCallBack) As Integer
    Declare Function SetPageNumber Lib "fleng32.dll" (ByVal Channel As Integer, ByVal PageNumber As Integer) As Integer
    Declare Function SetPrinterProperty Lib "fleng32.dll" (ByVal OptionIndex As Integer, ByVal Value As String) As Integer
    Declare Function SetPrintOptions Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Mode As Integer, ByVal Selection As Integer, ByVal PScale As Double, ByVal AScale As Double, ByVal xoff As Double, ByVal yoff As Double, ByVal Copies As Integer) As Integer
    Declare Function SetPrintStamp Lib "fleng32.dll" (ByVal Channel As Integer, ByVal TextString As String, ByVal Position As Integer, ByVal DateAndTimeVal As Integer, ByVal Background As Integer, ByVal Font As String, ByVal Size As Integer, ByVal Style As String, ByVal Last As Integer) As Integer
    Declare Function SetRedEntityProperties Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Handle As String, ByVal PropIndex As Integer, ByVal PropertyString As String, ByVal RedrawFlag As Integer) As Integer
    Declare Function SetRedLayerSettings Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayerName As String, ByVal IndexFlag As Integer, ByVal ValueString As String) As Integer
    Declare Function SetRedlineFileStatus Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String, ByVal PropertyIndex As Integer, ByVal PropertyValue As Integer, ByVal Reserved As String) As Integer
    Declare Function SetRedlinePath Lib "fleng32.dll" (ByVal Channel As Integer, ByVal FileName As String) As Integer
    Declare Function SetViewPoint Lib "fleng32.dll" (ByVal Channel As Integer, ByVal X1 As Double, ByVal Y1 As Double, ByVal Z1 As Double) As Integer
    Declare Function ShowAllLinks Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function StartLinkFlash Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LinkHandle As Integer, ByVal Duration As Integer, ByVal ForeGround As Integer, ByVal Background As Integer) As Integer
    Declare Function StartMeasure Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Mode As Integer) As Integer
    Declare Function StopDrawing Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function StopLinkFlash Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LinkHandle As Integer) As Integer
    Declare Function SyncLinkFlash Lib "fleng32.dll" (ByVal Channel As Integer, ByVal SyncLevel As Integer) As Integer
    Declare Function TogglePrintText Lib "fleng32.dll" (ByVal Channel As Integer, ByVal Mode As Integer) As Integer
    Declare Function UpdateRedlineAttributes Lib "fleng32.dll" (ByVal Channel As Integer, ByVal TagFile As String, ByVal Delimiter As String, ByVal EndOfLine As String) As Integer
    Declare Function ViewLayout Lib "fleng32.dll" (ByVal Channel As Integer, ByVal LayoutName As String) As Integer
    Declare Function ViewStoredView Lib "fleng32.dll" (ByVal Channel As Integer, ByVal ViewName As String) As Integer
    Declare Function ZoomDuringSelection Lib "fleng32.dll" (ByVal Channel As Integer) As Integer
    Declare Function ZoomToRect Lib "fleng32.dll" (ByVal Channel As Integer, ByVal X1 As Double, ByVal Y1 As Double, ByVal X2 As Double, ByVal Y2 As Double) As Integer

    Declare Function GetWindowsDirectory Lib "kernel32.dll" Alias "GetWindowsDirectoryA" (ByVal WinPath As String, ByVal Size As Integer) As Integer
    Declare Function GetPrivateProfileString Lib "kernel32.dll" Alias "GetPrivateProfileStringA" (ByVal fieldsection As String, ByVal inifield As String, ByVal DefaultStr As String, ByVal FLPath As String, ByVal Size As Integer, ByVal FLUserIni As String) As Integer
    Declare Function GetPrivateProfileInt Lib "kernel32.dll" Alias "GetPrivateProfileIntA" (ByVal fieldsection As String, ByVal inifield As String, ByVal DefaultNo As Integer, ByVal FLUserIni As String) As Integer
    Declare Function WritePrivateProfileString Lib "kernel32.dll" Alias "WritePrivateProfileStringA" (ByVal fieldsection As String, ByVal inifield As String, ByVal FLPath As String, ByVal FLUserIni As String) As Integer
    Declare Function FreeLibrary Lib "kernel32.dll" (ByVal LibHandle As Integer) As Integer
    Declare Function LoadLibrary Lib "kernel32.dll" Alias "LoadLibraryA" (ByVal FLLib As String) As Integer
    Declare Function WinHelp Lib "user32.dll" Alias "WinHelpA" (ByVal hWndMain As Integer, ByVal lpszHelp As String, ByVal uCommand As Integer, ByVal dwData As Integer) As Integer
    Declare Function DeleteObject Lib "Gdi32.dll" (ByVal hObject As Integer) As Integer


    Function SendFLCommandWithHelp(ByVal ThisChannel As Integer, ByVal Index As fl_cmd, Optional ByVal ThirdParam As Integer = 0) As Integer
        'just a wrapper around SendFLCommand which gives you selectable indexes, rather than having to look up the numbers
        Return SendFLCommand(ThisChannel, Index, ThirdParam)
    End Function

    Function GetFLStatusWithHelp(ByVal ThisChannel As Integer, ByVal Index As fl_status) As Integer
        'just a wrapper around GetFLStatus which gives you selectable indexes, rather than having to look up the numbers
        Return GetFLStatus(ThisChannel, Index)
    End Function

    Function GetFLConfigWithHelp(ByVal ThisChannel As Integer, ByVal Index As fl_cfg, ByRef FlagNo As Integer, ByRef StrVal As String) As Integer
        'just a wrapper around SetFLConfig which gives you selectable indexes, rather than having to look up the numbers
        Dim retVal As Integer
        Dim Answer As New String(vbNullChar, 256)
        retVal = GetFLConfig(ThisChannel, Index, FlagNo, Answer)
        StrVal = Strings.Left(Answer, InStr(Answer, Chr(0)) - 1)
        Return retVal
    End Function

    Function SetFLConfigWithHelp(ByVal ThisChannel As Integer, ByVal Index As fl_cfg, ByVal FlagNo As Integer, ByVal StrVal As String) As Integer
        'just a wrapper around SetFLConfig which gives you selectable indexes, rather than having to look up the numbers
        Return SetFLConfig(ThisChannel, Index, FlagNo, StrVal)
    End Function

    Public Enum fl_cfg
        AUTO_REDRAW = 1
        'BACKGROUND_COLOR = 2
        PROMPT_FOR_MISSING_FILES = 3
        MEASURE_MULTIPLIER = 4
        USE_XREFS = 5
        DISP_WIDE_PLINES = 6
        ACAD_VIEW_MODE = 7
        CIRCL_SMOOTHNESS = 8
        MULITASK_RATE = 9
        USE_ACAD_16_COLOR = 10
        DISP_ALL_CAD_ATTR = 11
        USE_REDLINE_DIRECTORY = 12
        USE_LINK_DIRECTORY = 13
        USE_RED_OPTS_DIRECTORY = 14
        USE_LAYER_CFG_DIRECTORY = 15
        USE_DGN_FONT_LIBRARY = 16
        MEASURE_MULTIPLIER_DGN = 18
        MEASURE_UNITS = 19
        MEASURE_UNITS_DGN = 20
        AUTO_MAXIMIZE = 21
        INITIAL_ZOOM_STATE = 22
        PRINT_MULTITASK_RATE = 23
        DEFAULT_DGN_VIEW = 24
        USE_PCP_FILE = 25
        USE_ACAD_ASI_INI_FILE = 26
        USE_RED_SYMBOL_FILE = 27
        USE_LINK_SYMBOL_FILE = 28
        RASTER_CONTRAST = 29
        USE_GLOBAL_REDLINE_DEF_FILE = 30
        MONOCROME_VECTOR = 31
        USE_OVERLOOK_BUTTONS = 32
        PICK_BOX_SIZE = 33
        STORE_CLIP_IN_MEMORY = 34
        DEFAULT_PEN_WIDTH = 35
        EDIT_FLPCP = 36
        ScrollBars = 37
        SUPPRESS_WINDOW_BORDER = 38
        USE_GAS_GAUGE = 39
        ALLOW_ZOOMS = 40
        HAND_CURSOR_OVER_LINKS = 41
        DISPLAY_VIEWMARKS = 42
        VIEWMARK_COLOR = 43
        USE_PREVIOUS_LINK_ZOOM_STATE = 44
        LAYER_CONFIG_NAME = 45
        EXPORT_V2RDPI = 46
        EXPORT_PCP_FILE = 47
        EXPORT_V2RBM_HEIGHT = 48
        EXPORT_V2R_PENWIDTH = 49
        USE_DYNAMIC_PAN = 50
        'USE_3D_DISPLAY_MODE = 51
        USE_CAD_FONTS = 52
        USE_LAYOUT_TABS = 53
        MAX_ENTITY_SEGMENTS = 54
        MAX_HATCH_POINTS = 55
        MAX_SPLINE_POINTS = 56
        DEFAULT_FONT = 57
        BACKGROUND_COLOR = 64
    End Enum

    Public Enum fl_status
        REDLINE_ON = 1
        LINKING_ON = 2
        SCROLL_BARS_ON = 3
        AUTO_REDRAW_ON = 4
        BACKGROUND_COLOR = 5
        PROMPT_FOR_MISSING_FILES = 6
        INITIAL_ZOOM_STATE = 7
        FASTZOOMS_ON = 8
        USE_FONTS = 9
        USE_LINETYPES = 10
        USE_XREFS = 11
        WIDE_PLINES = 12
        ACAD_VIEW_MODE = 13
        CIRCLE_SMOOTHNESS = 14
        IS_ACAD = 16
        SUPPORTS_BWCOPY = 17
        SUPPORTS_ZOOM_SCALE = 18
        SUPPORTS_ZOOM_LIMITS = 19
        SUPPORTS_BLOCKS = 20
        SUPPORTS_LAYERS = 21
        SUPPORTS_VIEWS = 22
        SUPPORTS_VIEWPOINT = 23
        SUPPORTS_TIME_INFO = 24
        SUPPORTS_ASSOC_FILES = 25
        SUPPORTS_VECTOR_PRINT = 26
        CAN_ZOOM_PREVIOUS = 27
        CAN_RETRACE_LINK = 28
        DISPLAY_RED_ATTRIBUTES = 29
        AUTO_RED_ATT_EDIT_MODE = 30
        DISPLAY_RED_FILLS = 31
        RED_HIGHLIGHT_FILL_MODE = 32
        RED_SOLID_FILL_MODE = 33
        IN_MEASURE_MODE = 34
        GAS_GAUGE_ON = 35
        SUPPORTS_BLOCK_DATA = 36
        SUPPORTS_EXTENDED_DATA = 37
        SUPPORTS_DATABASE_LINKS = 38
        SUPPORTS_ENTITY_ID = 39
        SHOW_HIDDEN_LINKS = 40
        AUTO_FILL_ON = 41
        STILL_DRAWING = 42
        RED_FILE_EXISTS = 43
        LINK_FILE_EXISTS = 44
        OVERLOOK_EXISTS = 45
        IS_COMPARE_WINDOW = 46
        IMAGE_TYPE = 47
        MONOCHROME_VECTOR = 48
        CAN_ZOOM_IN = 49
        CAN_ZOOM_OUT = 50
        CAN_ZOOM_EXTENT = 51
        CAN_PAN = 52
        CONTRAST_LEVEL = 53
        TEXT_STAMP_ON = 54
        IS_OUTSIDEIN_FILE = 55
        CAN_COPY_TO_CLIP = 56
        CAN_DO_CLIP_CONFIG = 57
        CURRENT_PAGE_NUMBER = 58
        CAN_EXIT = 60
        DGN_MEASURE_UNITS = 61
        MEASURE_UNITS = 62
        GRAYSCALE_MODE = 78
        ORTHO_MODE = 79
        IN_PAPERSPACE = 80
        SUPPORTS_PAPERSPACE = 81
        AUTO_ZOOMS_ON = 84
        DOTS_PER_INCH = 85
        TOTAL_NUM_PAGES = 86
        SHOW_HAND_OVER_LINKS = 87
        SUPPORTS_OBJECT_DATA = 88
        SELECTION_MODE = 89
        DRAWING_MODE = 90
        RED_DISPLAY_VIEWMARKS = 91
        RED_VIEWMARK_COLOR = 92
        NUM_LAYOUTS = 93
        UNDO_ACTION = 94
        RESTORE_PREVIOUS_LINK_ZOOMSTATE = 95
        USER_RIGHTCLICK_MENU_ITEM = 96
        SUPPORTS_SHEETS = 97
        FILE_TYPE = 98
        IN_3D_ROTATE_MODE = 99
        USE_LAYOUT_TABS = 101
        MOUSE_MODE = 104
        AUTO_MAXIMIZE_ON = 105
        DYNAMIC_PAN_ON = 106

    End Enum

    Public Enum fl_cmd
        FILE_OPEN_FILE_DIALOG_WINDOWS = 199
        FILE_OPEN_FILE_DIALOG = 3
        FILE_SAVE_AS = 4
        FILE_PRINT = 7
        FILE_PRINT_SETUP = 24
        FILE_EXPORT = 68
        FILE_SEARCH = 126
        FILE_OVERLOOK_ON = 490
        FILE_OVERLOOK_OFF = 491
        FILE_TEXT_FIND_DLG = 725

        COPY_BITMAP = 70
        COPY_VECTOR = 71
        COPY_SELECTED_TO_CLIPBOARD = 425
        COPY_CLIPBOARD_CONFIG = 426

        DISP_REDRAW_NOW = 103
        DISP_ZOOM_EXTENTS = 10
        DISP_ZOOM_SCALE = 11
        DISP_ZOOM_IN = 12
        DISP_ZOOM_OUT = 13
        DISP_LAYER_CFG = 143
        DISP_LAYERS = 14
        DISP_BLOCKS = 15
        DISP_ZOOM_PREVIOUS = 65
        DISP_ZOOM_LIMITS = 66
        DISP_ACAD_VIEWS = 67
        DISP_MONOCHROME_MODE_ON = 175
        DISP_MONOCHROME_MODE_OFF = 176
        DISP_ROTATE_CLOCKWISE = 382
        DISP_ROTATE_COUNTERCLOCKWISE = 384
        DISP_ROTATE_TO_90 = 385
        DISP_ROTATE_TO_180 = 386
        DISP_ROTATE_TO_270 = 387
        DISP_ROTATE_TO_0 = 388
        DISP_INVERT_BW = 410
        DISP_CONTRAST_LIGHTEST = 419
        DISP_CONTRAST_LIGHT = 420
        DISP_CONTRAST_DARK = 421
        DISP_CONTRAST_DARKEST = 422
        DISP_PAPERSPACE_ON = 435
        DISP_PAPERSPACE_OFF = 436
        DISP_LAYOUTS = 437
        DISP_GRAYSCALE_ON = 461
        DISP_GRAYSCALE_OFF = 462
        DISP_GOTO_PAGE = 492
        DISP_PREV_PAGE = 493
        DISP_NEXT_PAGE = 494
        DISP_FIRST_PAGE = 495
        DISP_LAST_PAGE = 496
        DISP_ZOOM_IN_50_ATCURSOR = 497
        DISP_VIEW_POINT = 21
        DISP_PAN = 23
        DISP_ROTATE_3D = 798


        RED_DRAW_LEADER = 73
        RED_MOVE_ENTITY = 75
        RED_DELETE_ENTITY = 76
        RED_REDLINE_ON = 92
        RED_DRAW_LINE = 94
        RED_DRAW_BOX = 95
        RED_DRAW_CIRCLE = 96
        RED_EDIT_NOTE = 97
        RED_DRAW_SKETCH = 98
        RED_DRAW_NOTE = 99
        RED_DELETE_FILE = 100
        RED_PREFERENCES = 102
        RED_DRAW_ARC_CSE = 118
        RED_DRAW_PLINE = 119
        RED_DRAW_CLOUD = 120
        RED_ATTRIBUTES_ON = 138
        RED_SEND_TAG_ON_CLICK = 142
        RED_MAKE_ATTR_TAGS = 145
        RED_CAD_IMPORT = 147
        RED_HATCH_MODE = 148
        RED_DELETE_ALL_HATCH = 149
        RED_HATCH_PATTERN_DLG = 150
        RED_SET_HATCH_TYPE = 152
        RED_SET_HATCH_WIDTH = 153
        RED_SEND_PLINE_AREA = 156
        RED_REDLINE_OFF = 161
        RED_DISPLAY_FILLS_ON = 203
        RED_DISPLAY_FILLS_OFF = 204
        RED_SOLID_FILL_MODE_ON = 205
        RED_SOLID_FILL_MODE_OFF = 206
        RED_HIGHLIGHT_FILL_MODE_ON = 207
        RED_HIGHLIGHT_FILL_MODE_OFF = 208
        RED_DRAW_STICKY_NOTE = 209
        RED_FILL_CLOSED_ENTITY = 210
        RED_CREATE_SYMBOL = 211
        RED_INSERT_SYMBOL = 212
        RED_DRAW_ARC_3POINT = 213
        RED_DRAW_ARC_SER = 214
        RED_SELECTION_MODE_ON = 215
        RED_SELECTION_MODE_OFF = 216
        RED_COPY_ENTITY = 226
        RED_ATTRIBUTES_OFF = 227
        RED_CHANGE_LAYER = 228
        RED_EDIT_ENTITY_W_TAG = 391
        RED_AUTO_FILL_ON = 392
        RED_AUTO_FILL_OFF = 393
        RED_EDIT_NOTE_W_ATTR = 395
        RED_PREFERENCES_W_ATTR = 397
        RED_REDLINE_OPTIONS = 398
        RED_CAPTURE_DWG_ENTITIES = 400
        RED_ORTHO_MODE_ON = 463
        RED_ORTHO_MODE_OFF = 464
        RED_DISPLAY_VIEWMARKS = 510
        RED_ADD_VIEWMARK = 511

        LINK_LINKING_OFF = 162
        LINK_SHOW_HIDDEN_ON = 164
        LINK_SHOW_HIDDEN_OFF = 165
        LINK_GOTO_FIRST_LINK = 167
        LINK_DRAW_PLINE = 168
        LINK_GOTO_PREVIOUS_LINK = 104
        LINK_DRAW_BOX = 105
        LINK_DELETE_ENTITY = 106
        LINK_MOVE_ENTITY = 107
        LINK_RESIZE_ENTITY = 108
        LINK_EDIT_LINK_ATTR = 109
        LINK_LINKING_ON = 110
        LINK_DELETE_FILE = 111
        LINK_HISTORY = 135
        LINK_SELECTION_MODE_ON = 217
        LINK_SELECTION_MODE_OFF = 218
        LINK_DRAW_CIRCLE = 405
        LINK_DRAW_CLOUD = 406
        LINK_INSERT_SYMBOL = 407
        LINK_COPY_ENTITY = 409

        INFO_GET_ATTRIBUTES = 171
        INFO_GET_DBASE_LINKS = 172
        INFO_GET_EXTENDED_DATA = 173
        INFO_IDENTIFY_ENTITY = 174
        INFO_GET_OBJECT_DATA = 177
        INFO_TIME = 51
        INFO_DWG_INFO = 52
        INFO_CALIBRATE_MEASURE = 411
        INFO_MEASURE_DISTANCE = 79
        INFO_MEASURE_MULTI_DISTANCE = 80
        INFO_ASSOCIATED_FILES = 116
        INFO_MEASURE_POLYGON_AREA = 390

        OPT_LAYOUT_TABS_ON = 717
        OPT_LAYOUT_TABS_OFF = 718
        OPT_LINETYPE_ON = 719
        OPT_LINETYPE_OFF = 720
        OPT_CADFONT_ON = 721
        OPT_CADFONT_OFF = 722
        OPT_SET_HPGL_PEN_COLORS = 381
        OPT_GAS_GAUGE_ON = 200
        OPT_GAS_GAUGE_OFF = 201
        OPT_SCROLLBARS_OFF = 169
        OPT_SYSTEM_COLOR_OFF = 170
        OPT_CONFIGURE = 124
        OPT_SCROLLBARS_ON = 125
        OPT_SAVE_OPTIONS = 60
        OPT_SYSTEM_COLOR_ON = 62

        HELP_ABOUT_DIALOG = 9
    End Enum

End Module